#! /usr/bin/env python
# -*- coding: utf8 -*-

#===============================================================================
# Author: Anol Paisal
#===============================================================================

#version:
#2.5.324 - New plugin

import os
import sys
import re
import common as cf
import logging

logger = logging.getLogger('.'.join([os.path.splitext(os.path.basename(sys.argv[0]))[0],'manager','filtergraph',__name__]))
skipclose = True

class filter(object):

	cfg= {
		'encoding': 'utf8',
		'escape-with': '%(url)s',
		'old-domain': '',
		'new-domain': '',
		'inputfile': '',
		'outputfile': '',
		'version': '2.5.321',
		}
	encoding = 'utf8'
	escape_with = '%(url)s'
	old_domain = '.com'
	new_domain = '.com'
	inputfile = ''
	outputfile = ''
	isopen = False
	p = object
	errors = []

	def open(self,parent,cfg):
		self.encoding = 'utf8' if 'utf8' in cfg['encoding'].lower().replace('-','') else cfg['encoding']
		self.inputfile = cfg['inputfile'].replace('%(rootfolder)s',self.p.rootfolder) if cfg['inputfile'] else self.inputfile
		self.outputfile = cfg['outputfile'].replace('%(rootfolder)s',self.p.rootfolder) if cfg['outputfile'] else self.outputfile
		if (self.inputfile and not self.outputfile) or (not self.inputfile and self.outputfile):
			self.errors.append([__name__,'invalid','[%s] inputfile=%s without outputfile= value'%(__name__,cfg['inputfile'])])
			logger.warn('%s\t%s',*self.errors[-1][1:])
		# found at: http://daringfireball.net/2010/07/improved_regex_for_matching_urls
		restring = r'(?i)\b((?:[a-z][\w-]+:(?:/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:\'".,<>?«»“”‘’]))'
		self.regex = re._compile(restring, re.IGNORECASE | re.UNICODE)
		self.escape_with = cfg['escape-with'] if cfg['escape-with'] else  self.escape_with
		self.old_domain = cfg['old-domain'] if cfg['old-domain'] else  self.old_domain
		self.new_domain = cfg['new-domain'] if cfg['new-domain'] else  self.new_domain

	def run(self,k):
		global skipclose
		skipclose = not self.inputfile
		if self.inputfile: return

		ksrc = list(k)
		ksrc[cf.rdrlang] = ksrc[cf.srclang]
		ksrc = tuple(ksrc)

		if ksrc in self.p.cfextract:
			for i,line in enumerate(self.p.cfoutput[k]['tempbuff']):
				replacewith = self.regex.search(self.p.cfextract[ksrc]['tempbuff'][i])
				if replacewith is None: continue
				self.p.cfoutput[k]['tempbuff'][i] = line.replace(self.escape_with,replacewith.group().replace(self.old_domain,self.new_domain,1))

	def flush(self,k):
		return

	def close(self):
		if skipclose: return

#		import codecs
#		from progress_bar import ProgressBar

#		if not os.path.exists(self.inputfile):
#			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.inputfile)])
#			logger.error('%s\t%s',*self.errors[-1][1:])
#			return

#		# make output folder
#		try:
#			os.makedirs(os.path.dirname(self.outputfile))
#		except OSError,e:
#			if not e.errno == 17:
#				logger.exception('%s\t%s, %s, %s',*['failed',e.errno,e.strerror,e.filename,])
#				raise OSError(e)

#		# open input and output files
#		out = self.outputfile
#		if out == self.inputfile:
#			import tempfile
#			fd,out = tempfile.mkstemp(suffix='.tmp', prefix='~', dir=self.p.tempdir)
#			os.close(fd)
#		try:
#			o = codecs.open(out,'w',self.encoding)
#			i = codecs.open(self.inputfile,'r',self.encoding)
#			ttl_lines = cf.file_length(self.inputfile)
#		except:
#			raise RuntimeError('Failed to open [%s] input/output files'%(__name__))

#		progress = ProgressBar()
#		progress.reset(0,ttl_lines,72,mode='fixed',char='#')
#		sys.stderr.write('[%s] %s\n'%(__name__,self.outputfile))

#		try:
#			# loop writes output line-by-line
#			for line in i:
#				o.write('%s\n'%(self.regex.sub(self.escape_with,line.rstrip('\r\n'))))
#				progress.increment_amount()
#				sys.stderr.write(progress.bar)
#				sys.stderr.flush()
#			sys.stderr.write('\n')
#			progress.update_amount(ttl_lines)
#			sys.stderr.write(progress.bar)
#			sys.stderr.write('\n')
#			sys.stderr.flush()
#			# close input and output files
#			i.close()
#			o.close()

#			if not out == self.outputfile:
#				import shutil
#				shutil.move(out,self.outputfile)

#		except KeyboardInterrupt:
#			os.unlink(out)
#			raise KeyboardInterrupt()

#		if not os.path.exists(self.outputfile):
#			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.outputfile)])
#			logger.error('%s\t%s',*self.errors[-1][1:])

def usage():
	'''Command prompt help.'''
	return "\n%s\n\tUsage:\n\tfrom %s import filter\n"%(
	os.path.basename(sys.argv[0]),
	os.path.splitext(os.path.basename(sys.argv[0]))[0]
	)

licensetxt=u'''DoMY™ Pro v2.5
Copyright © 2010-2012 Precision Translation Tools Co., Ltd.
All rights reserved.'''

if __name__ == "__main__":
	import os
	import sys
	sys.stdout.write(usage().encode('utf8')+'\n')
